<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>frontend documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="./images/favicon.ico">
	      <link rel="stylesheet" href="./styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="./" class="navbar-brand">frontend documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content getting-started">
                   <div class="content-data">

<h1 id="chvote-2-0-backoffice-frontend-project">CHVote-2.0 BackOffice Frontend project</h1>
<h2 id="continuous-integration-test-reports">Continuous Integration Test Reports</h2>
<p><a href="https://chvote2.gitlab.io/chvote-bo/">https://chvote2.gitlab.io/chvote-bo/</a></p>
<h2 id="must-read">Must read</h2>
<ul>
<li><a href="https://gitlab.com/chvote2/documentation/chvote-docs/blob/master/development-directives/coding-style-FrontEnd.md">Coding style for FrontEnd development</a></li>
</ul>
<h2 id="prerequisites">Prerequisites</h2>
<ul>
<li>Install NodeJS and NPM - <a href="https://nodejs.org/en/download/">https://nodejs.org/en/download/</a></li>
<li>Install Angular CLI plugin</li>
</ul>
<p><code>npm install -g @angular/cli</code></p>
<h2 id="install-required-node-modules-">Install required node modules.</h2>
<p>Inside project directory :</p>
<p><code>npm install</code></p>
<h2 id="ui-components-to-use">UI Components to use</h2>
<ul>
<li><p>All Angular Material components </p>
</li>
<li><p>DateTime Picker : Angular 2 Datetime Picker</p>
<ul>
<li><a href="https://github.com/ng2-ui/datetime-picker">Site</a> </li>
</ul>
</li>
</ul>
<h2 id="global-error-handler">Global error handler</h2>
<p>Unhandled JavaScript errors are catched by <code>GlobalErrorHandled</code> which :</p>
<ul>
<li>logs error to the browser console</li>
<li>calls a REST endpoint of the server to centralize logs, in order to ease diagnostic. </li>
</ul>
<p>see <code>GlobalErrorHandler</code> in frontend project and <code>FrontEndLoggerController</code> in backend project</p>
<h2 id="server-error-handling">Server error handling</h2>
<p>HttpService must be used to call remote REST services, as it defines a global error handling strategy.</p>
<p>see <code>HttpService</code></p>
<h3 id="business-errors">Business errors</h3>
<p>Business validation errors are received as HTTP responses with status code 400 and a ValidationErrorModel payload.</p>
<p>Calling component should declare an error handler to handle known business validation errors. To do so, one must set &#39;errorHandled&#39; property to true.</p>
<div><pre class="line-numbers"><code class="language-none">  retrieveOperations(): void {
    this.operationService.findAll().subscribe(
      operations =&gt; {
        // on success handler
      },
      err =&gt; {
        let error = err as ValidationErrorModel;
        if (error.exceptionClassName.indexOf(&quot;ImportOperationRepositoryException&quot;)) {
          // do something with business error

          // mark the error as being handled
          error.errorHandled=true;
        }
      }
    );
  }</code></pre></div><p>Error interceptor will check that property to determine if business error has been handled by the calling component. If not, a generic business error popup will be shown.</p>
<p>see <code>BusinessErrorDialogComponent</code></p>
<h3 id="technical-errors">Technical errors</h3>
<p>Technical errors (typically RuntimeException) are received as HTTP responses with status code 500 and a TechnicalErrorVo payload.</p>
<p>Error interceptor will first display a technical error dialog box and then call component&#39;s error handler.</p>
<p>see <code>TechnicalErrorDialogComponent</code></p>
<h2 id="i18n">I18N</h2>
<h3 id="selected-component">Selected component</h3>
<p>Angular native I18N is still in beta and requires to bundle one application per language. It does not allow to change language on the fly.</p>
<p>We use <a href="https://github.com/ngx-translate/core">ngx-translate</a> instead.</p>
<h3 id="usage">Usage</h3>
<ul>
<li>pipe : <code>{{ &#39;footer.content&#39; | translate:footerParam }}</code> </li>
<li>service : <code>translate.get(&#39;HELLO&#39;, {value: &#39;world&#39;}).subscribe((res: string) =&gt; { console.log(res); });</code></li>
<li>directive : <code>&lt;div [translate]=&quot;&#39;HELLO&#39;&quot; [translateParams]=&quot;{value: &#39;world&#39;}&quot;&gt;&lt;/div&gt;</code></li>
</ul>
<h3 id="translation-files">Translation files</h3>
<h4 id="location">Location</h4>
<p>Translation file are modularized by component. They are written in typescript and are merged in a global i18n.ts file</p>
<h2 id="resources">Resources</h2>
<h3 id="angular-documentation">Angular Documentation</h3>
<p><a href="https://angular.io/docs/ts/latest/guide/architecture.html">Architecture overview</a></p>
<p><a href="https://angular.io/docs/ts/latest/guide/template-syntax.html">Template syntax</a></p>
<p><a href="https://angular.io/docs/ts/latest/guide/forms.html">Forms</a></p>
<p><a href="https://angular.io/docs/ts/latest/cookbook/form-validation.html">Form Validation</a></p>
<p><a href="https://angular.io/docs/ts/latest/guide/reactive-forms.html">Reactive Forms</a></p>
<p><a href="https://angular.io/docs/ts/latest/guide/testing.html">Testing</a></p>
<p><a href="https://angular.io/docs/ts/latest/cookbook/component-communication.html">Component interaction</a></p>
<p><a href="https://angular.io/docs/ts/latest/cookbook/dependency-injection.html">Dependency Injection</a></p>
<p><a href="https://angular.io/docs/ts/latest/guide/security.html">Security</a></p>
<p><a href="https://angular.io/docs/ts/latest/guide/router.html">Routing and Navigation</a></p>
<p><a href="https://angular.io/docs/ts/latest/guide/ngmodule.html">Modules</a></p>
<p><a href="https://angular.io/docs/ts/latest/guide/server-communication.html">HTTP Server communication</a></p>
<p><a href="https://angular.io/docs/ts/latest/guide/cheatsheet.html">CheatSheet</a></p>
<h3 id="angular-material">Angular Material</h3>
<p><a href="https://material.angular.io/components">Components</a></p>
<p><a href="https://github.com/angular/material2#feature-status">Feature status</a></p>
<h3 id="terradata-covalent-components">Terradata Covalent components</h3>
<p><a href="https://teradata.github.io/covalent/#/">Covalent home page</a></p>
<h3 id="angular-2-flex-layout">Angular 2 Flex Layout</h3>
<p><a href="https://tburleson-layouts-demos.firebaseapp.com/#/docs">Angular 2 Flex Layout demo</a></p>
<p><a href="https://github.com/angular/flex-layout/tree/master/src/demo-app/app">Angular 2 Flex Layout demo source code</a></p>
<p><a href="https://github.com/angular/flex-layout/wiki/API-Documentation">Angular 2 Flex Layout documentation</a></p>
<h2 id="flexbox-layout">Flexbox Layout</h2>
<p><a href="https://css-tricks.com/snippets/css/a-guide-to-flexbox/">A Complete Guide to Flexbox</a></p>


















                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 0;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'getting-started';
            var COMPODOC_CURRENT_PAGE_URL = 'index.html';
       </script>

       <script src="./js/libs/custom-elements.min.js"></script>
       <script src="./js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="./js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="./js/menu-wc.js" defer></script>

       <script src="./js/libs/bootstrap-native.js"></script>

       <script src="./js/libs/es6-shim.min.js"></script>
       <script src="./js/libs/EventDispatcher.js"></script>
       <script src="./js/libs/promise.min.js"></script>
       <script src="./js/libs/zepto.min.js"></script>

       <script src="./js/compodoc.js"></script>

       <script src="./js/tabs.js"></script>
       <script src="./js/menu.js"></script>
       <script src="./js/libs/clipboard.min.js"></script>
       <script src="./js/libs/prism.js"></script>
       <script src="./js/sourceCode.js"></script>
          <script src="./js/search/search.js"></script>
          <script src="./js/search/lunr.min.js"></script>
          <script src="./js/search/search-lunr.js"></script>
          <script src="./js/search/search_index.js"></script>
       <script src="./js/lazy-load-graphs.js"></script>


    </body>
</html>
